"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const context_js_1 = require("../context.js");
const Opacity = () => {
    const { handleOpacity, opacity, tinyColor, squareSize } = (0, context_js_1.usePicker)();
    const [dragging, setDragging] = (0, react_1.useState)(false);
    const { r, g, b } = tinyColor.toRgb();
    const bg = `linear-gradient(90deg, rgba(255,255,255,0) 0%, rgba(${r},${g},${b},.5) 100%)`;
    const stopDragging = () => {
        setDragging(false);
    };
    const handleDown = () => {
        setDragging(true);
    };
    const handleMove = (e) => {
        if (dragging) {
            handleOpacity(e);
        }
    };
    const handleClick = (e) => {
        if (!dragging) {
            handleOpacity(e);
        }
    };
    let left = squareSize - 18;
    // const handleKeyboard = (e) => {
    //   if (inFocus === 'opacityHandle') {
    //       if (e.keyCode === 37) {
    //         let newValue = Math.max(opacity * 100 - 1, 0);
    //         handleOpacity({ type: 'picker-keyboard', value: newValue })
    //       } else if (e.keyCode === 39) {
    //         let newValue = Math.min(opacity * 100 + 1, 100);
    //         handleOpacity({ type: 'picker-keyboard', value: newValue })
    //       }
    //   }
    // }
    //
    // useEffect(() => {
    //   window.addEventListener('keydown', handleKeyboard);
    //
    //   return () => {
    //     window.removeEventListener('keydown', handleKeyboard);
    //   };
    // }, [opacity, inFocus, value]);
    (0, react_1.useEffect)(() => {
        const handleUp = () => {
            stopDragging();
        };
        window.addEventListener('mouseup', handleUp);
        return () => {
            window.removeEventListener('mouseup', handleUp);
        };
    }, []);
    return (react_1.default.createElement("div", { onMouseDown: handleDown, onMouseMove: (e) => handleMove(e), className: "c-resize ps-rl", style: { height: 14, marginTop: 17, marginBottom: 4 } },
        react_1.default.createElement("div", { style: { width: '100%', height: 14 }, className: "rbgcp-checkered" }),
        react_1.default.createElement("div", { style: { left: left * opacity, top: -2 }, className: "rbgcp-handle" }),
        react_1.default.createElement("div", { style: { background: bg }, className: "rbgcp-opacity-overlay", onClick: (e) => handleClick(e) })));
};
exports.default = Opacity;
